#!/usr/bin/env python

"""
qq26_pyqtdesigner.pyw

A simple demonstration to show how to use custom widgets and Qt Designer forms.

Copyright (C) 2008 Trolltech ASA. All rights reserved.

This file is part of the documentation of Qt. It was originally
published as part of Qt Quarterly.

This file may be used under the terms of the GNU General Public License
version 2.0 or 3.0 as published by the Free Software Foundation or under
the terms of the Qt Commercial License Agreement. The respective license
texts for these are provided with the open source and commercial
editions of Qt. In addition, as a special exception, Trolltech
gives you certain additional rights. These rights are described in the
Trolltech GPL Exception version 1.2, which can be found at
http://www.trolltech.com/products/qt/gplexception/ and in the file
GPL_EXCEPTION.txt in the package for the open source edition of Qt.

If you are unsure which license is appropriate for your use, please
review the following information:
http://www.trolltech.com/products/qt/licensing.html or contact the
sales department at sales@trolltech.com.

This file is provided "AS IS" with NO WARRANTY OF ANY KIND,
INCLUDING THE WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE. Trolltech reserves all rights not expressly
granted herein.
"""

import sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from QQ_Widgets.ui_window import Ui_Window

class Window(QWidget, Ui_Window):

    def __init__(self, parent = None):
    
        QWidget.__init__(self, parent)
        self.setupUi(self)
    
    @pyqtSignature("on_pushButton_clicked()")
    def on_pushButton_clicked(self):
    
        lat = self.globeWidget.latitude = self.geolocationWidget.latitude
        lng = self.globeWidget.longitude = self.geolocationWidget.longitude
        self.listWidget.addItem(
            u"%i\xb0 %i' %i\" N, " % self.dms(lat) + \
            u"%i\xb0 %i' %i\" E" % self.dms(lng))
    
    def dms(self, value):
    
        d = int(value)
        m = int((value - d) * 60)
        s = (value - d - m/60.0) * 3600
        return d, m, s


if __name__ == "__main__":

    app = QApplication(sys.argv)
    window = Window()
    window.show()
    sys.exit(app.exec_())
